function y = split(s, str),

% SPLIT return the front/back of the lens prescription, starting
% from the given INDEX element.
% 
% SPLIT(s, {'front','back'}). Specifiying 'front' takes all 
% elements prior to and including the current one. Specifying 
% 'back' takes all elements from the current to the last.

strType = get(s.optic{s.current},'type');
if (~strcmp(strType,'index')),
   error('(SPLIT) Cant split on a non-INDEX');
   return
end

if (nargin == 1),
    str = 'first';
end 

switch(str)
    case {'front'}
       y = optic;
       for  k=1:(s.current),
            y.optic{k} = s.optic{k};
       end
       y.total = s.current;
       y.current = 1;
    case {'back'}
       if (s.current == 1)
            y = s;
           return
       end
       y = optic;
       for  k=s.current:s.total,
            y.optic{k-s.current+1} = s.optic{k};
       end
       y.total  = s.total-s.current+1;
       y.current = 1;
   otherwise,
       error('(SPLIT) Unknown option passed.'); 
end

return
