function y = get(s, varargin),

% GET return field of PRIM
%
% GET(prim, field). Return field of PRIM
%
% GET(p,'arg',field). Return argument field of the primitive. 
%
% GET(p,'args'). Return all argument field values of the primitive. 
%
% GET(p, x, y, str).  Return derivatives (identified by str) 
% of PRIM at x,y.  
%

if (nargin == 2),
    % can't access args field directly
    if (strcmp(varargin{1}, 'args')),
        y = getarg(s);
        return
    end
    y = s.(varargin{1});
    return
elseif (nargin == 3),
    
    % default height 
    if (isnumeric(varargin{1})),
        y = getsf(s, varargin{:});
        return
    end
        
    % return arguments
    if (strcmp(varargin{1}, 'args')),
        y = getarg(s, varargin{2});
        return
    end
    
elseif (nargin == 4),
    
    % specified height/derivative
    if (isnumeric(varargin{1})),
        y = getsf(s, varargin{:});
        return
    end
    
end

error('(GET) invocation not known.');

return
