function [s, n] = getarg(s, field),

% GETARG return the specific surface arguments for the surface.   
% 
% GETARG(s) return the complete list of arguments.
%
% GETARG(s, field) return the value of field 
%

% return a complete list
if (nargin == 1), 
    s = s.args.value;
    return
end

n = strcellmatch(field, s.args.name);
if (n > 0), 
   s = s.args.value{n};
   return;
end
   
error('(GETARG) Unknown field.');
return
