function h = plot(s, strF, strArrow),

% PLOT show spot-diagram with option to  
% translate the spot-diagram to a new position.
% 
% PLOT(s).  Show the current rays on a spot diagram. 
%
% PLOT(s, strF). Set strF to '2D' or '3D' to give a 2D
% plot or a 3D plot.
%
% This function calls : ARROW.M with details below :
% Copyright (c)1995-2002, Dr. Erik A. Johnson <JohnsonE@usc.edu>, 11/15/02

% 24/11/04 added a return if empty 

clf;

if (nargin == 1),
    strF = '2D';
    strArrow = 'off';
elseif (nargin == 2),
    strArrow = 'off';
end 

switch(lower(strF)),
    case {'2d' }
        ng = 1000;
        plot(s.position(:,1), s.position(:,2),'rx');
    case {'3d' }
        ng = 1;
        plot3(s.position(:,1), s.position(:,2), s.position(:,3), 'rx');
    otherwise,
        error('(PLOT) Unknown invocation.');
end 

if (strcmp(strArrow, 'on')),
    h = ishold; hold on;
    h = arrow(s.position, s.position+ ng*s.slope);
    h = arrow(h,'EdgeColor','b');
    h = arrow(h,'FaceColor','b');
    h = arrow(h,'Length',4);

    if (h),
        hold on;
    else
        hold off;
    end
end 

return
