function [nPos, nSlope] = createray(nSou, nTarg, varargin),

% CREATERAY make rays from source and target matrices. 
%
%  [posn, slope] = CREATERAY(source, target, myflag). The position and 
%  slope of a ray are returned according to the dimensions of the  
%  source and target matrices.  Setting MyFlag to Source or target 
%  places the initial position at the source or target position 
%  (default is Source if omitted) 
%  

% bug fix : 6/11/06 - added one target many sources 
% old method rays corresponding to the sources in  
% reverse order (rays OK though ) !!! 

nSlope = big_norm(nTarg - nSou);

if (~isempty(varargin)),
    switch(varargin{1}),
        case {'source'}, nPos = nSou;
        case {'target'}, nPos = nTarg;
        otherwise,
         error('(MAKERAY) Unknown option requested.');
    end 
else 
    nPos = nSou;
end 

return