function [ s, I, N ] = refractat(myelement,s,n1,n2,I),

% REFRACTAT refract at the surface
% 
% [ s, I ] = refractat(myelement,s,I,n1,n2),
% 
% where 
%           myelement = the element at hand
%           s         = rays object
%           I         = indexes
%           n1        = medium #1 index 
%           n2        = medium #2 index 
%

% -------------------------------------------------------
% CODE CHANGES
% -------------------------------------------------------
%
% 28/10/04  eliminate complex rays (shifted to raytrak2)
% 
% 6/5/04    code required changes. 'plane' and 'pupil' require proper refraction routines - fixes not done.
%
% 29/1/04   changed InInfo  = [ myelement.position myelement.abc ] to InInfo  = [ 0 0 0 myelement.abc ]
% because the surfaces are now used in an element centered frame (and thereby dont required shifting 
% information.
% 

X = get(s,'posn');
M = get(s,'slope');
myelement = struct(myelement);

[X,M,I,N] = refractatsurface(myelement,X,M,I,n1,n2);

s = set(s,'posn',X);
s = set(s,'slope',M);  
return
