function [rays,I] = rtraceto(rays, myelement, I),

% RTRACETO call the correct functions to do the tracing.
% 
% [rays, I] = rtraceto(myelement,rays,I),
%
% assuming surface centered frame. 

% 23/12 added creation of default index created if not supplied 


    if (nargin == 2),
        I = (1:length(rays))';
    end 

    % put into canonical frame 
    angle       = get(myelement,'orient');
    origin      = get(myelement,'position');
    
    % disp('RTRACETO');
    % pause;
    % show(rays)
    
    rays      = shift(rays,-origin);              
    rays      = rotate(rays, angle, [0 0 0]);    
    
    % show(rays)
    
    % struct(myelement)
    
    % canonical ray trace
    [rays,I] = traceto(rays, myelement, I);

    % put back into standard frame  
    rays              = rotate(rays, -angle, [0 0 0]);
    rays              = shift(rays,origin);
    
    % show(rays)
    
return
