function [RR,M1,I1] = traypln1(InInfoA, InInfoB, InInfoC, I1)

% disp('I');
% size(I1)
% size(InInfoB)
% function [x1,y1,z1,I1] = traypln0(x0,y0,z0,u0,v0,w0,X,R,I1)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                       %
% traypln0.m                            %
%                                       %
% compute a matrix of intersections %
% I1 is flag of successes matrix        %
%                                       %
% PLANE AT (x0, y0, z0)                 %
% NORMAL AT (0,0,1)                     %
%                                       %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% local mask
w0  = InInfoB(:,3);
I   = (1:1:size(w0,1))';    % local mask


% keep only possible rays
I   = I(w0~=0);

% remove anti-parallel rays
cx  = InInfoC(1,1);
cy  = InInfoC(1,2);
cz  = InInfoC(1,3);
z0  = InInfoA(I,3);
P   = sign((cz-z0).*w0) == 1;
I   = I(P==1);

% P
% I
% sign((cz-z0).*w0)
% cz 
% z0
% w0

% I
% InInfoB
% disp('pluck it!')
% cz
% z0
% w0
% input('wait.');
 
% InInfoB(1,3)
%  size(I)
% cz
% z0(1:5)
% w0(1:5)
% input('wait...');

% pluck only parallel lines 
e       = InInfoC(5);
if      e > 0

        disp('plucking...');
  
        z0 = InInfoA(I,3);
    w0 = InInfoB(I,3);

        E = abs((z0 - cz)./w0);
    E = E.*sqrt(1-w0.^2);        
    
    I = I(E<e); % error incurred on the image plane

% I = I((w0>(1-e)&(w0<1));      
%   min(w0)
%   size(I)
%       
% e
% E=E(E<e);
% E(1:10)
% input('wait...');

         b = E<e;
         disp(['plucked = ' num2str(size(b,1))])        

     if isempty(I)
       disp('warning: all plucked out');
       RR = [];
       M1 = [];
       I1 = [];
       return
     end
     
     
end


dr  = InInfoC(1,2);         %unused


% get direction vectors
u0  = InInfoB(I,1);
v0  = InInfoB(I,2);
w0  = InInfoB(I,3);
R   = sqrt(u0.^2 + v0.^2 + w0.^2);

% size(I)
% e
% dr
% size(u0)
% size(v0)
% size(w0)
%  size(R)

% discard illegal direction vectors
I   = I(R>0);
R   = R(R>0);

% u0
% v0
% w0
% sqrt(u0.^2 + v0.^2 + w0.^2)
% size(I)
% size(R)
% input('wait...');


% get the remainder
x0  = InInfoA(I,1);
y0  = InInfoA(I,2);
z0  = InInfoA(I,3);

x0      = InInfoA(I,1);
y0      = InInfoA(I,2);
z0      = InInfoA(I,3);
u0  = InInfoB(I,1);
v0  = InInfoB(I,2);
w0  = InInfoB(I,3);

%  size(R)
%  size(u0)
% size(u0)
% size(R)

u0  = u0./R;
v0  = v0./R;
w0  = w0./R;
L   = abs((z0 - cz)./w0);

% discard rays out of extent
dr  = InInfoC(1,4);

rx = u0.*L+x0 - cx;     % distance from aperture center
ry = v0.*L+y0 - cy;     % distance from aperture center
dE  = sqrt(rx.^2+ry.^2);

I  = I(dE<dr);
x0 = x0(dE<dr);
y0 = y0(dE<dr);
z0 = z0(dE<dr);
u0 = u0(dE<dr);
v0 = v0(dE<dr);
w0 = w0(dE<dr);
L  = L(dE<dr);

I1 = I1(I);
% trace to the plane
RR = [ u0.*L+x0 v0.*L+y0 w0.*L+z0 ];
M1 = [ u0 v0 w0 ];
