% RAYTRACE, a Ray-Tracing Toolbox
%  Version 1.0.0 16-Mar-2007
%   by Jason Turuwhenua 
% 
%   Ray-tracing objects.
%       ray     -   A class for holding ray information. 
%       prim    -   A class for holding optical surface information.
%       optic   -   A class for holding a lens prescription.
%
%   Composite system level functions 
%       rayloc      - determine rays passing through given points                  
%       raynsect    - intersect ray objet with surface object
%
%   Ray-tracing functions
%       step        - Ray-trace current surface of lens prescription                 
%       trace       - Ray-trace complete lens prescription               
%       focus       - Find best focus
%
%   Wavefront functions.
%       pfn         - pupil fn. from lens prescription.                  
%       pfn2dmtf    - pupil fn. to modulation transfer fn. (MTF).             
%       pfn2dotf    - pupil fn. to optical transfer fn. (OTF).             
%       pfn2psf     - pupil fn. to point spread function (PSF).
%       pfnAiry     - pupil fn. for diffraction limited system              
%       pfnComa     - pupil fn. to coma               
% 
%   External plotting functions   
%       plot_lens   -   show lens prescriptions             
%       plot_ray    -   show rays             
%       plot_pfn    -   show pupil function             
%
%   Paraxial optical functions.
%       parax       - Paraxial description from lens prescription                           
%       pObj2Img    - Convert object point to image point               
%       pImg2Obj    - Convert image point to object point              
%
%   Worker functions
%       reflect     - law of reflection                 
%       refract     - snell's law 
%
%   Demonstration programs 
%       demo1       -                
%       demo2       -                 
% 
%   Required?
%       bend.m                 
%