function [m_nPos, m_j] = trace_img(nPos, nSlope, nAp)

% TRACE_IMG intersect a origin centered conic surface
% with a ray (nPos, nSlope). 
%
% TRACE_IMG(nPos, nSlope, nAp).  Here nPos is the position,
% nSlope is the ray slope, nAp is the aperture. The intersection 
% point is returned as well as an index into the rays that are remaining.
% 
% NOTE :
%   This Fn. calls TRACE_PUPIL 

if (nargin == 1),
    if (strcmp(nPos, 'type')),
        m_nPos = 'analytic'; m_j = [];
        return
    end
    error('(TRACE_IMG) Error in invocation.');
end

[m_nPos, m_j] = trace_pupil(nPos, nSlope, nAp);
return