function k = getProperty(strVar, strList, pDefVal),

% GETPROPERTY Return the property and value pair from the cell array 
%
% pVal = GETPROPERTY(strVar, strList, pDefVal).  Here strVar is the required  
% variable, strList is a cell array and pDefVal is the default value if 
% that variable does not exist.
%
%

  if (isempty(strList)),
      k = pDefVal;
      return
  end
  
  l = strcmp(strVar, strList);
  if (any(l)),
      k = find(l > 0); 
      k = strList{k+1};
      return
  end
  
  k = pDefVal;
return