function [a, b, fa, fb] = getValidInt(strObjFn, a, b, x0, varargin),

% GETVALIDINT return a valid interval for locating intersections. 
%
% [a, b] = GETVALIDINT(FunFcn, nPos, nSlope, a, b, varargin),
%
% NOTE : 
%     a=nan, b=nan no intersection with bounding box (missed or coaxial)
%     a = 0  | b > 0   bounded by current location and b. 
%     a > 0  | b > 0   intersections possible     
%
% try and get 
%
% NB :
%
%   assumes (a < b)
% 
%   there is a possibility for an error involving the  
%   fact that 10*eps has been subtracted from findrayintervals.  
%   This could lead to a missing the surface.  
%   
%   Possibly fix by adding a check that tests whether the interval    
%   calculated actually corresponds to finite values !!!

%%%%%%%%%%%%%%%%%%%%%
% nPos
% nSlope
% a
% b
% nAp
% varargin{:}
% keyboard;

nd = (1:size(x0,1))';

% valid intervals
fa = feval(strObjFn, a, x0, varargin{:});%-nPosA(:, 3);
fb = feval(strObjFn, b, x0, varargin{:});%-nPosB(:, 3);

% remaining 
j = isfinite(fa.*fb);
if  all(j),
    % fprintf('(GETVALIDINT) done.\n');
    return
end

% 1st adjust phase 
cnt = 0;
while(cnt < 100),
    % single adjust step
    j = isnan(fa);
    if (any(j)),
        ep = min([ (b(j)-a(j))/100 ; b(j)*0+0.1 ])'; 
        a(j)=a(j)+ep; 
        % a0 = repmat(a(j),1,3); nPosA(j,:) = nSlope(j,:).*a0 + nPos(j,:);    
        fa(j) = feval(strObjFn, a(j), x0(j,:), varargin{:}); %-nPosA(j,3);
    end 
    j = isnan(fb);
    if (any(j)),
        ep = min([ (b(j)-a(j))/100 ; b(j)*0+0.1 ])'; 
        b(j)=b(j)-ep; 
        % b0 = repmat(b(j),1,3); nPosB(j,:) = nSlope(j,:).*b0 + nPos(j,:);    
        fb(j) = feval(strObjFn, b(j), x0(j,:), varargin{:}); %-nPosB(j,3);
    end 
    % remaining 
    j = isfinite(fa.*fb);
    if  all(j),
%        fprintf('(GETVALIDINT) done.\n');
        return
    end
    cnt = cnt + 1;
end

% 2nd adjust slow - should check along the for each interval.
% error('(GETVALIDINT) implement interval search.');

% theres an error
error('(GETVALIDINT) non-finite objective function.');
return