function [p, x, rsq] = make_pupil(N,d)
%
% MAKE_PUPIL [p, x, rsq] = make_pupil(N,d)
%
%  r is the FFT cell size (in normalized pupil coordinates)
%  N is the number of points in the cell (should be power of 2)
%
% Example  
%   pupil = make_pupil(128,2*8)
%   r=[-8, 8], 128 divisions 
%   pupil will be at 1
%
% Taken from :
% http://www.engr.udayton.edu/faculty/jloomis/eop601/matlab/psf/fft_psf.html
% last accessed : Feb 2007


r = d/2;
x = linspace(-r,r,N+1);
x = ones(N,1)*x(1:N);   % outer product
xsq = x.*x;
rsq = xsq+xsq';
p = rsq<=1.0;

return
