function x = eye_gull1_accom, 

% EYE_GULL1_ACCOM Gullstrand 1 Eye : Accommodated.
%
%   
%   #   n       r       d       p       description
%
%       1.0000                          air
%   1           7.700                   
%       1.3760          0.5000  0.5000  cornea
%   2           6.800                   
%       1.3360          2.7000  3.2000  aqueous
%   3           5.333                   
%       1.3860          0.6725  3.8725  lens: cortex
%   4           2.655
%       1.4060          2.6550  6.5275  lens: core
%   5           -2.655
%       1.3860          0.6725  7.2000  lens: cortex
%   6           -5.333
%       1.3360                          vitreous
%
% OBTAINED FROM : 
%
%  Appendix 3 - Schematic Eyes (p. 781)
%  The Eye and Visual Optical Instruments
%  Smith, G. and Atchison, D.A., 
%  Cambridge University Press, 1997.

  x = optic;
  x = addon(x, 'index','air',1.0000); 
  x = addon(x, 'sphere', 'anterior cornea', 'refract', [0 0 0], [0 0 0], 7.7, 7.7); 
  x = addon(x, 'index','cornea', 1.3760); 
  x = addon(x, 'sphere','posterior cornea','refract',[0 0 0.5],[0 0 0], 6.8, 6.8);
  x = addon(x, 'index', 'aqueous', 1.3360);
  x = addon(x, 'sphere', 'anterior lens', 'refract', [0 0 3.2], [0 0 0], 5.333, 5.333);   
  x = addon(x, 'index', 'lens: cortex', 1.3860);
  x = addon(x, 'sphere', 'anterior lens', 'refract', [0 0 3.8725], [0 0 0], 2.655, 2.655);   
  x = addon(x, 'index', 'lens: core', 1.4060);
  x = addon(x, 'sphere', 'anterior lens', 'refract', [0 0 6.5275], [0 0 0], 2.655, -2.655);   
  x = addon(x, 'index', 'lens: cortex', 1.3860);
  x = addon(x, 'sphere', 'posterior lens', 'refract', [0 0 7.2000], [0 0 0], 5.333, -5.333);   
  x = addon(x, 'index', 'vitreous', 1.3360);
  x = addon(x, 'img','image','refract', [0 0 21.016], [0 0 0],inf);
  x = gohead(x); 

return