function x = eye_gull1_relaxed, 

% EYE_GULL1_RELAXED. Gullstrand 1 Eye : Relaxed.
%
%   
%   #   n       r       d       p       description
%
%       1.0000                          air
%   1           7.700                   
%       1.3760          0.5000  0.5000  cornea
%   2           6.800                   
%       1.3360          3.1000  3.6000  aqueous
%   3           10.000                   
%       1.3860          0.546   4.146   lens: cortex
%   4           7.911
%       1.4060          2.419   6.565   lens: core
%   5           -5.760
%       1.3860          0.635   7.200   lens: cortex
%   6           -6.000
%       1.3360                          vitreous
%
% OBTAINED FROM : 
%
%  Appendix 3 - Schematic Eyes (p. 781)
%  The Eye and Visual Optical Instruments
%  Smith, G. and Atchison, D.A., 
%  Cambridge University Press, 1997.


  x = optic;
  x = addon(x, 'index','air',1); 
  x = addon(x, 'sphere', 'anterior cornea', 'refract', [0 0 0], [0 0 0], 7.700, 7.700); 
  x = addon(x, 'index','cornea', 1.3760); 
  x = addon(x, 'sphere','posterior cornea','refract', [0 0 0.5],[0 0 0], 6.800, 6.800);
  x = addon(x, 'index','aqueous', 1.3360);
  x = addon(x, 'sphere', 'anterior lens', 'refract', [0 0 3.6], [0 0 0], 10.000, 10.000);   
  x = addon(x, 'index','lens: cortex', 1.3860);
  x = addon(x, 'sphere', 'anterior core', 'refract', [0 0 4.146], [0 0 0], 7.911, 7.911);   
  x = addon(x, 'index','lens: core', 1.4060);
  x = addon(x, 'sphere', 'posterior core', 'refract', [0 0 6.565], [0 0 0], 5.760, -5.760);   
  x = addon(x, 'index','lens: cortex', 1.3860);
  x = addon(x, 'sphere', 'posterior lens', 'refract', [0 0 7.200], [0 0 0], 6, -6);   
  x = addon(x, 'index','vitreous', 1.3360);
  x = addon(x, 'img','image','refract',[0 0 24.385], [0 0 0],inf);
  x = gohead(x); 

return