function x = eye_gull2_accom, 

% EYE_GULL2_ACCOM. Gullstrand 2 Eye : Accommodated.
%
%   
%   #   n       r       d       p       description
%
%       1.0000                          air
%   1           7.800                   
%       4/3             3.2     3.2     aqueous
%   2           5.000                   
%       1.4160          4.0000  7.2000  lens
%   3           -5.000                   
%       4/3                             vitreous
%
% OBTAINED FROM : 
%
%  Appendix 3 - Schematic Eyes (p. 789)
%  The Eye and Visual Optical Instruments
%  Smith, G. and Atchison, D.A., 
%  Cambridge University Press, 1997.

  x = optic;
  x = addon(x, 'index','air',1); 
  x = addon(x, 'sphere', 'anterior cornea', 'refract', [0 0 0], [0 0 0], 7.800, 7.800); 
  x = addon(x, 'index','aqueous', 4/3); 
  x = addon(x, 'sphere','anterior lens','refract', [0 0 3.2], [0 0 0], 5.000, 5.000);
  x = addon(x, 'index','aqueous', 1.4160);
  x = addon(x, 'sphere', 'posterior lens', 'refract', [0 0 7.2], [0 0 0], 5.000, -5.000);   
  x = addon(x, 'index','vitreous', 4/3);
  x = addon(x, 'img','image','refract',[0 0 21.252], [0 0 0],inf);
  x = gohead(x); 

return
