function x = eye_gull2_relaxed, 

% EYE_GULL2_RELAXED. Gullstrand 2 Simplified Eye : Relaxed.
%
%   
%   #   n       r       d       p       description
%
%       1.0000                          air
%   1           7.800                   
%       4/3             3.6     3.6     aqueous
%   2           10.000                   
%       1.4160          3.6     7.2000  lens
%   3           -6.000                   
%       4/3                             vitreous
%
% OBTAINED FROM : 
%
%  Appendix 3 - Schematic Eyes (p. 788)
%  The Eye and Visual Optical Instruments
%  Smith, G. and Atchison, D.A., 
%  Cambridge University Press, 1997.

  x = optic;
  x = addon(x, 'index','air',1); 
  x = addon(x, 'sphere', 'anterior cornea', 'refract', [0 0 0], [0 0 0], 7.800, 7.800); 
  x = addon(x, 'index','aqueous', 4/3); 
  x = addon(x, 'sphere','anterior lens','refract', [0 0 3.6], [0 0 0], 10.000, 10.000);
  x = addon(x, 'index','aqueous', 1.4160);
  x = addon(x, 'sphere', 'posterior lens', 'refract', [0 0 7.2], [0 0 0], 6.000, -6.000);   
  x = addon(x, 'index','vitreous', 4/3);
  x = addon(x, 'img','image','refract',[0 0 23.896], [0 0 0],inf);
  x = gohead(x); 

return
